unit Load1;

{$mode objfpc}{$H+}

{APPTYPE CONSOLE}


interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons;

type

  { TFormLoad }

  TFormLoad = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    ScrollBar3: TScrollBar;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit4Enter(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormLoad: TFormLoad;

implementation


{$R *.lfm}

//function Sscanf(const s: string; const fmt : string;
//const Pointers : array of Pointer) : Integer;

{ Sscanf выполняет синтаксический разбор входной строки. Параметры...

s - входная строка для разбора
fmt - 'C' scanf-форматоподобная строка для управления разбором
%d - преобразование в Long Integer
%f - преобразование в Extended Float
%s - преобразование в строку (ограничено пробелами)
другой символ - приращение позиции s на "другой символ"
пробел - ничего не делает
Pointers - массив указателей на присваиваемые переменные


результат - количество действительно присвоенных переменных


Например, ...
Sscanf('Name. Bill   Time. 7:32.77   Age. 8',
'. %s . %d:%f . %d', [@Name, @hrs, @min, @age]);


возвратит ...
Name = Bill  hrs = 7  min = 32.77  age = 8 }

type
  XYZ= Record
    X,Y,Z:Real;
  end;
CorAr=array of XYZ;
type
  FR= Record
    A,B,C,AB,BC,CA:Integer;
  end;
 AFR =array of fr;
Var
av:CorAr;
af:AFR;
Const
  CF:LongInt=0;
//-------------------------------------

function Sscanf(const s: string; const fmt : string;

const Pointers : array of Pointer) : Integer;
var

i,j,n,m : integer;
s1      : string;
L       : LongInt;
X       : Extended;


function GetInt : Integer;
begin
s1 := '';
while (s[n] = ' ')  and (Length(s) > n) do inc(n);
while (s[n] in ['0'..'9', '+', '-'])
and (Length(s) >= n) do begin
s1 := s1+s[n];
inc(n);
end;
Result := Length(s1);
end;


function GetFloat : Integer;
begin
s1 := '';
while (s[n] = ' ')  and (Length(s) > n) do inc(n);
while (s[n] in ['0'..'9', '+', '-', '.', 'e', 'E'])
and (Length(s) >= n) do begin
s1 := s1+s[n];
inc(n);
end;
Result := Length(s1);
end;


function GetString : Integer;
begin
s1 := '';
while (s[n] = ' ')  and (Length(s) > n) do inc(n);
while (s[n] <> ' ') and (Length(s) >= n) do
begin
s1 := s1+s[n];
inc(n);
end;
Result := Length(s1);
end;


function ScanStr(c : Char) : Boolean;

begin
while (s[n] <> c) and (Length(s) > n) do inc(n);
inc(n);


If (n <= Length(s)) then Result := True
else Result := False;
end;


function GetFmt : Integer;
begin
Result := -1;


while (TRUE) do begin
while (fmt[m] = ' ') and (Length(fmt) > m) do inc(m);
if (m >= Length(fmt)) then break;


if (fmt[m] = '%') then begin
inc(m);
case fmt[m] of
'd': Result := vtInteger;
'f': Result := vtExtended;
's': Result := vtString;
end;
inc(m);
break;
end;


if (ScanStr(fmt[m]) = False) then break;
inc(m);
end;
end;
 var e :Integer;

begin

n := 1;
m := 1;
Result := 0;


for i := 0 to High(Pointers) do begin
j := GetFmt;


case j of
vtInteger : begin
if GetInt > 0 then begin
L := StrToInt(s1);
Move(L, Pointers[i]^, SizeOf(LongInt));
inc(Result);
end
else break;
end;


vtExtended : begin
if GetFloat > 0 then begin
 val (s1,x,e);
 //if E<>0 THEN WRITELN (s1,' ',x);
 //X := StrToFloat(s1);
 Move(X, Pointers[i]^, SizeOf(Extended));
 inc(Result);
 end
else break;
end;


vtString : begin
if GetString > 0 then begin
Move(s1, Pointers[i]^, Length(s1)+1);
inc(Result);
end
else break;
end;


else break;
end;
end;
end;
//*****************************************************************
{ TFormLoad }
Var
  v11,v12,v13,v21,v22,v23,v32,v33,v43,
  screen_dist:real;

Const C1:real=4.5;c2:Real=3.5;
//Пересчет каординат
procedure Persp(x,y,z:Real;var XX,YY:Real);
var
xe,ye,ze:real;
begin

xe:=v11*x+v21*y;
ye:=v12*x+v22*y+v32*z;
ze:=v13*x+v23*y+v33*z+v43;

XX:=Screen_dist*xe/Ze+c1;
YY:=Screen_dist*ye/Ze+c2;
end;
Var vx,vy,Color:Integer;
// 3d Линия из текущйг точки
Procedure dw(x,y,z:real{C:TConvas});
var xx,yy: Real;
  x1,y1:Integer;
begin
persp(x,y,z,xx,yy);
{x1:=Round(XX*50);Y1:=Round(yy)*50;}
x1:=10+trunc(XX*(50+FormLoad.ScrollBar1.Position))
+FormLoad.ScrollBar2.Position-50;
Y1:=10+trunc(yy*(50+FormLoad.ScrollBar1.Position))
+FormLoad.ScrollBar3.Position-50;
;

FormLoad.Panel1.Canvas.line(vx,vy,X1,y1);
vx:=x1;vy:=y1;
end;

// 3В Премещение кисти
Procedure Mw(x,y,z:real);
var xx,yy: Real;
  x1,y1:Integer;
begin
persp(x,y,z,xx,yy);
//vx:=20+trunc(XX*50);vY:=20+trunc(yy*50);

vx:=10+trunc (XX*(50+FormLoad.ScrollBar1.Position))
+FormLoad.ScrollBar2.Position-50;
vy:=10+trunc(yy*(50+FormLoad.ScrollBar1.Position))
+FormLoad.ScrollBar3.Position-50;
end;
// Для записи XYZ
Procedure DWPoint3d(P:XYZ);
begin
Dw(P.X,P.Y,P.Z);
end;
Procedure MWPoint3d(P:XYZ);
begin
MW(P.X,P.Y,P.Z);
end;
///==============================

// поворот пространства


procedure cof(Rho,theta,phi:real);
var
ph,  th,costh,sinth,cosph,sinph,Factor:real;
begin
Factor:=pi/180;
th:=theta*factor; ph:=phi*factor;
Costh:=cos(th); sinth:=Sin(th);
Cosph:=cos(ph); sinph:=Sin(ph);
v11:= -sinth;v12:=-cosph*costh;v13:=-sinph*Costh;
v21:=costh; v22:=-cosph*Sinth; v23:=-sinph*sinth;
            v32:=sinph;        v33:=-Cosph;
                               v43:=rho;
end;

procedure TFormLoad.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin

end;
var p, i,j,k,iu,ju,ku, x,y,s,shag:Real;
const FF:Boolean =true ;

Function CTF(S:String):Boolean;
 var
  R:Real;
  E:Integer ;
begin
 Val(S,R,E);
 Ctf:=(E=0) and (R<>0);

end;
// Остановка вращения
procedure TFormLoad.Button1Click(Sender: TObject);
begin
if ctf(Edit1.Text) then I:=StrToFloat(Edit1.Text);
if ctf(Edit2.Text) then j:=StrToFloat(Edit2.Text);
if ctf(Edit3.Text) then K:=StrToFloat(Edit3.Text);
if ctf(Edit4.Text) then CF:=StrToInt(Edit4.Text);

self.Timer1.Enabled:=not Timer1.Enabled;

end;
//Загрузка модели
procedure TFormLoad.Button2Click(Sender: TObject);
begin
if OpenDialog1.Execute then
     memo1.Lines.LoadFromFile(opendialog1.FileName);
end;

// Парсинг
procedure TFormLoad.Button3Click(Sender: TObject);
var I,NN,A,b,c,AB,BC,CA:longint;
    S:String;
    X,Y,Z :Extended;
    VF,FF:Boolean;


begin
Vf:=False;
Ff:=False;
CF:=0;
if memo1.Lines.Count=0 then exit;
SetLength(AV,memo1.Lines.Count);
for I:=0 to memo1.Lines.Count-1 do
begin
 if vf then
 begin
 // Парсинг вершин
  If pos ('Vertex',memo1.Lines[i])=1 then
  begin
  Sscanf(memo1.Lines[i],'Vertex %d: X: %f Y: %f Z: %f',[@NN,@X,@Y,@Z]);
  av[i].x:=X;
  av[i].y:=Y;
  av[i].z:=z;
  memo2.Lines.add(format('[ %d ] X= %f Y= %f Z= %f ',[NN,X,Y,Z]));
  end
 end;
 //Face 0:    A:0 B:1 C:2 AB:1 BC:1 CA:0
 if ff then
 begin
// парсинг полегонов
  If pos ('Face',memo1.Lines[i])=1 then
  begin
   CF:=CF+1;
   SetLength(AF,CF);
// af[cf-1]
   Sscanf(memo1.Lines[i],'A:%d B:%d C:%d AB:%d BC:%d CA:%d' ,
    [@A,@B,@C,@AB,@BC,@CA]);
    af[cf-1].A:=a;af[cf-1].B:=B;af[cf-1].C:=C;
    af[cf-1].AB:=ab;af[cf-1].BC:=BC;af[cf-1].CA:=CA;
    memo2.Lines.add(format('A= %d B= %d C= %d AB= %d BC= %d CA= %d ',
    [A,B,C,AB,BC,CA]));
  end;
 end;
 //поиск начала списков
   if not vf then
  vf:= pos ('Vertex list:',memo1.Lines[i])=1;
 if not Ff then
  Ff:= pos ('Face list:',memo1.Lines[i])=1;
end ;
Label1.Caption:=intToStr(Cf);
Edit4.Text:=intToStr(Cf);
end;
// Обработка при вводе углов поворта
procedure TFormLoad.Edit1Change(Sender: TObject);
begin
if ctf(Edit1.Text) then I:=StrToFloat(Edit1.Text);
if ff then Timer1Timer(Sender);
end;

procedure TFormLoad.Edit2Change(Sender: TObject);
begin
if ctf(Edit2.Text) then j:=StrToFloat(Edit2.Text);
if ff then Timer1Timer(Sender);
end;

procedure TFormLoad.Edit3Change(Sender: TObject);
begin
if ctf(Edit3.Text) then
k:=StrToFloat(Edit3.Text);
if ff then Timer1Timer(Sender);
end;

procedure TFormLoad.Edit4Change(Sender: TObject);
begin
//CF:=StrToInt(edit4.Text);
end;

procedure TFormLoad.Edit4Enter(Sender: TObject);
begin
//CF:=StrToInt(edit4.Text);
end;

//Kub
procedure drawKub( Rho,theta,phi:real);
const h=50;
{c:Integer;}
begin
{
cof(Rho,theta,phi);

}
mw(h,-h,-h);dw(h,h,-h);
dw(-h,h,-h);
dw(-h,h,h);
dw(-h,-h,h);
dw(h,-h,h);
dw(h,-h,-h);
mw(h,h,-h);dw(h,h,h);
dw(-h,h,h);
mw(h,h,h);dw(h,-h,h);
mw(h,-h,-h);dw(-h,-h,-h);
dw(-h,h,-h);
mw(-h,-h,-h);dw(-h,-h,h);

end;

procedure TFormLoad.FormCreate(Sender: TObject);

begin
screen_dist:=2;
J:=30;k:=70;
Ju:=30;ku:=70;
i:=100; iu:=200;
Shag:=4;
//cof(i+8,j,k);
//drawKub(i+8,j,k);

end;

procedure TFormLoad.Timer1Timer(Sender: TObject);
 Var
  LI:LongInt;
begin
ff:=False;
self.Panel1.Canvas.Clear;
cof(i,j,k);
if CF=0 then drawKub(i,j,k);
if abs(Ju-j)<=2*Shag then
  JU:=j+80-Random(80)
  else if JU<j Then J:=j-Shag else J:=j+Shag;
if abs(ku-k) <=2*Shag then
  kU:=k+150-Random(150)
    else if (kU>k) { abs(ku-k) <2*Shag}
    Then k:=k-Shag else k:=k+Shag;
if (iu=i) then begin
  iU:= i+50-Random(100);
  IF iu<100 then iu:=100;
  IF iu>500 then iu:=300;
  end
  else if  iU<i Then i:=i-1 else i:=i+1;

if CF=0 then begin
 //  cof(i+8,j,k);
 //  drawKub(i+8,j,k);

mw(0,0,50);dw(0,0,0);
mw(50,50,50);dw(-50,-50,50);
mw(-50,50,50);dw(50,-50,50);
// Color:=14;
p:=0; S:=pi/(2+Random(6));
while P<2*pi do begin
mw(0,0,0);dw(20*Cos(p),20*Sin(p),-25+random(15));
p:=P+s;
end;
p:=0;x:=0; S:=pi/(2+Random(6));
mw((x+20)*Cos(p),(x+20)*Sin(p),-25+x/2);
while P<4*pi do begin
//Color:=Random(15);
{mw((x+20)*Cos(p),(x+20)*Sin(p),-25+x/2);}
X:=x+3;
dw((X+20)*Cos(p),(x+20)*Sin(p),-25+x/2);
p:=P+s;
end
end  else
//Показ модели
begin
//MWPoint3d(AV[AF[0].A]);

for LI:=0 to CF-1 do
 begin
 MWPoint3d(AV[AF[lI].A]);
 dWPoint3d(AV[AF[LI].b]);
 dWPoint3d(AV[AF[LI].c]);
 dWPoint3d(AV[AF[lI].A]);


// dWPoint3d(AV[AF[LI].ab]);
 //dWPoint3d(AV[AF[LI].bc]);
// dWPoint3d(AV[AF[LI].cA]);

   end;
end;
Edit1.Text:=FloatToStr(i);
Edit2.Text:=FloatToStr(j);
Edit3.Text:=FloatToStr(k);
ff:=True;

end;

end.

